/*
 * OperatorsView.java
 *
 * Created on 10 de agosto de 2004, 18:04
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import java.util.Vector;

import com.fenalco.entities.LogisticOperatorList;
import com.fenalco.entities.User;

import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.LogisticOperatorListView;

/**
 * Este servlet prepara la información requerida por <CODE>
 * operadoreslogisticos.jsp</CODE> para mostrar un listado informativo de los
 * operadores logísticos que ofrecen sus servicios a través del sistema.
 * 
 * @author andres
 */

public class OperatorsView extends HttpServlet
{

	/**
	 * Inicializa el servlet
	 * 
	 * @param config
	 *            Parámetros de configuración del servlet
	 * @throws ServletException
	 *             Excepción que se lanza cuando el servlet no puede completar
	 *             esta operación exitosamente
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlett.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método crea un objeto <CODE>LogisticOperatorList</CODE> que recibe
	 * como parámetro una ciudad y lo envía a <CODE>operadoreslogisticos.jsp
	 * </CODE> como un atributo de response.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción que se lanza cuando este método no puede completar
	 *             la operación exitosamente
	 * @throws IOException
	 *             Excepción que se lanza cuando ocurre un error al utilizar el
	 *             <CODE>PrintWriter</CODE> incluido en el HTTP <CODE>Request
	 *             </CODE>.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
                            
                                // criterios de paginación
				int pagina = 1;
				int resultadosPagina = 20;
				int paginas; // numero total de páginas
				int inicio = 0; // numero del primero registro que se va a mostrar
				int fin = 9; // numero del último registro que se va a mostrar
				int total; // numero total de resultados
                                
                                String temp = request.getParameter("page");
                                if( temp == null ){
                                    
                                    pagina = 1;
                                    
                                }else{
                                
                                    pagina = Integer.parseInt( temp );
                                    
                                }
                                
                                pagina = (pagina < 1)? 1 : pagina;
                                temp = request.getParameter( "pageResults" );
                                
                                if( temp == null ){
                                    
                                    resultadosPagina = 20;
                                    
                                }else{
                                
                                    resultadosPagina = Integer.parseInt( temp );
                                    
                                }
                                
                                resultadosPagina = (resultadosPagina < 1)? 20 : resultadosPagina;
                                
                                
				LogisticOperatorList operatorList;
				if( request.getParameter("cityId") == null )
				{
					/*
					 * Listado por defecto --> Problema si la ciudad con id 1
					 * desaparece!! Solución: Constructor por omisión
					 */
					operatorList = new LogisticOperatorList(-1);
				}
				else
				{
					operatorList = new LogisticOperatorList(new Integer(request
							.getParameter("cityId")).intValue());
				}
	
                                Vector results = new Vector();
                                total = operatorList.getLogisticOperators().size();  
                                
                                paginas = (int) Math.ceil((double) total / (double) resultadosPagina);
                                
				if( pagina > paginas ){
					pagina = paginas;
				}
                                
				inicio = (pagina - 1) * resultadosPagina;
				fin = pagina * resultadosPagina;
				inicio = (inicio < 0) ? 0 : inicio;
                                
				if( fin > total ){
					fin = total;
				}
                                
				for( int i = inicio; i < fin; i++ ){
					results.addElement( operatorList.getLogisticOperators().elementAt(i) );
                                }
                                
                                operatorList.setLogisticOperators( results ); 
                                
				LogisticOperatorListView view = new LogisticOperatorListView(operatorList);
	
				if( view == null )
				{
					//Fallo en la creación del listado de operadores logísticos
					//message = "Fallo en la creación del listado de operadores
					// logísticos";
					message = MessageBuilder.buildMessage(9);
					url = "/proveedor/operadoreslogisticos.jsp";
				}
				else
				{
					//Todo OK
					//message = "La lista de operadores logísticos se creó
					// correctamente";
					//message = MessageBuilder.buildMessage(3);
					message = "";
					url = "/proveedor/operadoreslogisticos.jsp";
					request.setAttribute("view", view);
				}
                                
                                /// información de la paginacion
                                 inicio++; // para no arrancar desde 0
                                 inicio = (fin == 0) ? 0 : inicio;
                                 request.setAttribute("firstRow", inicio + "");
                                 request.setAttribute("lastRow", fin + "");
                                 request.setAttribute("total", total + "");
                                 request.setAttribute("page", pagina + "");
                                 request.setAttribute("pages", paginas + "");
                                 request.setAttribute("pageResults", resultadosPagina + "");
	
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }
		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción que se lanza cuando este método no puede completar
	 *             la operación exitosamente
	 * @throws IOException
	 *             Excepción que se lanza cuando ocurre un error al utilizar el
	 *             <CODE>PrintWriter</CODE> incluido en el HTTP <CODE>Request
	 *             </CODE>.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción que se lanza cuando este método no puede completar
	 *             la operación exitosamente
	 * @throws IOException
	 *             Excepción que se lanza cuando ocurre un error al utilizar el
	 *             <CODE>PrintWriter</CODE> incluido en el HTTP <CODE>Request
	 *             </CODE>.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet
	 * 
	 * @return Retorna una descripción general del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}